

A faire : 

manipulate_pythonpath()


Dépend de l'ajout du fichier control dans la DB locale
kill_processes_from_control
manual_proper_uninstall()
is_package_x64()
killalltasks

ask_for_configuration
unzip_with_7zip() filenames en 3 eme
programfiles64 == programfiles
add installed size in register_uninstall()

register_uninstall()

public_persistent_path()
private_persistent_path()

remove_allusers_desktop_shortcut()
remove_allusers_desktop_menu_shortcut
remove_tree_for_allusers(default_user=False)


fonction nettoyage du registre utilisateur en global - remove_reg_key_allusers 

    for tool_name in tools_list:
        for sid in ['.DEFAULT','S-1-5-18','S-1-5-19','S-1-5-20']:
            if not reg_value_exists(HKEY_USERS, r'%s\SOFTWARE\Sysinternals\%s' % (sid, tool_name), 'EulaAccepted'):
                registry_set(HKEY_USERS, r'%s\SOFTWARE\Sysinternals\%s' % (sid, tool_name), 'EulaAccepted', 1)






    if is_running_from_waptconsole():
        error("Please execute update_package() manually to update control.version")




def inifile_readstring(inifilename, section, key, **kwargs):
    r"""Read a string parameter from inifile

    >>> inifile_writestring(r"C:\waptdev\test.conf", section='Options', key="AeTrayMode", "64 Bits")

    >>> print(inifile_readstring(r"C:\waptdev\test.conf", section='Options', key="AeTrayMode"))
    '64 Bits'

    """
    import configparser

    inifile = configparser.RawConfigParser(**kwargs)
    inifile.read(inifilename)
    if inifile.has_section(section) and inifile.has_option(section, key):
        return inifile.get(section, key)
    else:
        return kwargs.get("default", None)




def wait_uninstallkey_present(key=None, max_loop=120, keywords=None, name=None, raise_on_timeout=False):

    if len([f for f in [key, keywords, name] if f]) > 1:
        error("Arguments conflict key: %s keywords: %s name: %s" % (key, keywords, name))

    if key:
        searchparam = "key: %s" % str(key)
    elif name:
        searchparam = "name: %s" % str(name)
    else:
        searchparam = "keywords: %s" % str(keywords)

    print("Waiting for %s to appear in Windows registry" % searchparam)
    loop = 0
    while not uninstall_key_exists(key, keywords=keywords, name=name):
        loop += 1
        if loop > max_loop:
            if raise_on_timeout:
                error("timeout after %s seconds" % max_loop)
            else:
                return "timeout after %s seconds" % max_loop
        time.sleep(1)


def wait_uninstallkey_absent(key=None, max_loop=120, keywords=None, name=None, raise_on_timeout=False):

    if len([f for f in [key, keywords, name] if f]) > 1:
        error("Arguments conflict key: %s keywords: %s name: %s" % (key, keywords, name))

    if key:
        searchparam = "key: %s" % str(key)
    elif name:
        searchparam = "name: %s" % str(name)
    else:
        searchparam = "keywords: %s" % str(keywords)
    print("Waiting for the removal of %s from Windows registry" % searchparam)
    loop = 0
    while uninstall_key_exists(key, keywords=keywords, name=name):
        loop += 1
        if loop > max_loop:
            if raise_on_timeout:
                error("timeout after %s seconds" % max_loop)
            else:
                return "timeout after %s seconds" % max_loop
        time.sleep(1)



def get_file_assocation(ext):
    r"""Return the associated application for a file extension (example : '.doc')
    >>> get_file_assocation('.pptx')
    'LibreOffice.Pptx'
    """
    try:
        return winreg.QueryValue(winreg.HKEY_CLASSES_ROOT, ext)
    except:
        return None


def get_default_app(suffix):
    r"""Return application path associated to a file extension (example: .pptx)
    >>> get_default_app('.pptx')
    'C:\\Program Files\\LibreOffice\\program\\simpress.exe'
    """
    try:
        class_root = winreg.QueryValue(winreg.HKEY_CLASSES_ROOT, suffix)
    except:
        return None
    with winreg.OpenKey(winreg.HKEY_CLASSES_ROOT, r'{}\shell\open\command'.format(class_root)) as key:
        command = winreg.QueryValueEx(key, '')[0]
        return shlex.split(command)[0]


def unzip(zipfn, target=None, filenames=None, extract_with_full_paths=True):
    r"""Unzip the files from zipfile with patterns in filenames to target directory
    Args:
        zipfn (str) : path to zipfile. (can be relative to temporary unzip location of package)
        target (str) : target location. Defaults to dirname(zipfile) + basename(zipfile)
        filenames (str or list of str): list of filenames / glob patterns (path sep is normally a slash)
        extract_with_full_paths (bool): keeping or not the subfolders of the archive as is
    Returns:
        list : list of extracted files
    >>> unzip(r'C:\example\tis-7zip_9.2.0-15_all.wapt')
    ['C:\\example\\tis-7zip_9.2.0-15_all\\7z920-x64.msi',
     'C:\\example\\tis-7zip_9.2.0-15_all\\7z920.msi',
     'C:\\example\\tis-7zip_9.2.0-15_all\\setup.py',
     'C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/control',
     'C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/wapt.psproj',
     'C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/manifest.sha256',
     'C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/signature']
    >>> unzip(r'C:\example\tis-7zip_9.2.0-15_all.wapt', filenames=['*.msi','*.py'])
    ['C:\\example\\tis-7zip_9.2.0-15_all\\7z920-x64.msi',
     'C:\\example\\tis-7zip_9.2.0-15_all\\7z920.msi',
     'C:\\example\\tis-7zip_9.2.0-15_all\\setup.py']
    >>> unzip(r'C:\example\tis-7zip_9.2.0-15_all.wapt', target='test', filenames=['*.msi','*.py'])
    ['C:\\example\\test\\7z920-x64.msi',
     'C:\\example\\test\\7z920.msi',
     'C:\\example\\test\\setup.py']
    >>> unzip(r'C:\example\tis-7zip_9.2.0-15_all.wapt', filenames='WAPT/*')
    ['C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/control',
     'C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/wapt.psproj',
     'C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/manifest.sha256',
     'C:\\example\\tis-7zip_9.2.0-15_all\\WAPT/signature']
    >>> unzip(r'C:\example\tis-7zip_9.2.0-15_all.wapt', filenames='WAPT/control')
    ['C:\\example\\tis-7zip_9.2.0-15_all\\WAPT\\control']
    >>> unzip('tis-7zip_9.2.0-15_all.wapt', target='.', filenames='WAPT/control')
    ['.\\WAPT\\control']
    >>> unzip(r'C:\example\tis-7zip_9.2.0-15_all.wapt', target=r'C:\example\', filenames='WAPT/control')
    ['C:\\example\\WAPT\\control']
    >>> unzip('tis-7zip_9.2.0-15_all.wapt', target=basedir, filenames='WAPT/control')
    ['C:\\example\\WAPT\\control']
    >>> unzip(r'C:\example\tis-7zip_9.2.0-15_all.wapt', filenames='WAPT/control', extract_with_full_paths=False)
    ['C:\\example\\control']
    .. versionadded:: 1.3.11
    .. versionchanged:: 2.2
        added extract_with_full_paths parameter
    """
    from waptutils import CustomZipFile
    import sys
    zipf = CustomZipFile(zipfn, allowZip64=True)
    if target is None:
        target = makepath(os.path.dirname(os.path.abspath(zipfn)), os.path.splitext(os.path.basename(zipfn))[0])

    if filenames is not None:
        filenames = [pattern.replace('\\', '/') for pattern in ensure_list(filenames)]

    def match(fn, filenames):
        # return True if fn matches one of the pattern in filenames
        if filenames is None:
            return True
        else:
            for pattern in filenames:
                if glob.fnmatch.fnmatch(fn, pattern):
                    return True
            return False

    if filenames is not None:
        files = [fn for fn in zipf.namelist() if match(fn, filenames)]
        members = files
    else:
        files = zipf.namelist()
        members = None

    if sys.platform != 'darwin' and extract_with_full_paths:
        zipf.extractall(target, members)
    elif not extract_with_full_paths:
        files_to_extract = files
        files = []
        os.makedirs(target, exist_ok=True)
        for fn in files_to_extract:
            filename = os.path.basename(fn)
            # skip directories
            if not filename:
                continue

            # copy file (taken from zipfile's extract)
            source = zipf.open(fn)
            files.append(os.path.join(filename))
            dest = open(os.path.join(target, filename), "wb")
            with source, dest:
                shutil.copyfileobj(source, dest)
    else: # the zipfile module doesn't support symlinks, and it's used in macOS packages
        try:
            members_str = " ".join('"{0}"'.format(m) for m in members) if members else ""
            unzip_cmd = 'unzip -qq {zipfile} {members_str} -d {destination_dir}'.format(
                                            zipfile=zipfn,
                                            members_str=members_str,
                                            destination_dir=target)
            run(unzip_cmd)
        except:
            print('Error : couldn\'t unzip {}'.format(zipfn))
            return []

    return [makepath(target, fn.replace('/', os.sep)) for fn in files]




def get_powershell_str(powershell_cmd, value=None):
    r"""Get a value as string from the output of a powershell command
    WARNING: Adding -AllUsers parameter may be necessary to make sure WAPT is enable to get the request value  

    Args:
        powershell_cmd (str): Powershell command
        value (str)         : Value to get as string

    .. versionadded:: 2.2

    """
    if value:
        return str(run_powershell('%s | Select-Object -ExpandProperty %s | Write-Host -NoNewline' % (powershell_cmd, value), output_format='text'))
    else:
        return str(run_powershell('%s | Write-Host -NoNewline' % powershell_cmd, output_format='text'))


def remove_appx(package, default_user=True):
    r"""Uninstall and remove Windows AppX package from the computer in machine and user environnement

    Args:
        package (str): package name, asterisk character (*) can be used as joker
        default_user (bool): Remove from image that will be installed for each new user

    .. versionadded:: 2.2

    """
    if running_as_admin() or running_as_system():
        run_powershell('Get-AppxPackage "%s" -AllUsers | Remove-AppxPackage -AllUsers' % package)
        if default_user:
            run_powershell('Get-AppXProvisionedPackage -Online | Where-Object DisplayName -Like "%s" | Remove-AppxProvisionedPackage -Online -AllUsers' % package)
    else:
        run_powershell('Get-AppxPackage "%s" | Remove-AppxPackage' % package)




def is_running_from_waptconsole():
    if os.path.basename(sys.executable.lower()).rsplit('.', 1)[0] == 'waptconsole':
        return True
    else:
        return False


def need_install(key='', min_version=None, force=False, get_version=None, keywords='', name=''):
    """Return True if the software with key can be found in uninstall registry
    and the registred version is equal or greater than min_version

    Args:
        key (str): uninstall key
        min_version (str): minimum version or None if don't check version (like when key is specific for each soft version)
        get_version (callable): optional func to get installed software version from one installed_softwares item
            if not provided, version is taken from 'version' attribute in uninstall registry
        keywords (str or list): string to lookup in key, display_name or publisher fields
        name (str regexp) : filter on a regular expression on software name

    Returns:
        boolean

    .. versionchanged:: 2.1
        added keywords and name

    """

    if force or (not bool(key) and not bool(keywords) and not bool(name)):
        return True
    elif len([i for i in [key, name, keywords] if i]) >= 2:
        error("Please only specify key or keywords or name")
    else:
        if key:
            current = installed_softwares(uninstallkey=key)
        if keywords:
            current = installed_softwares(keywords=keywords)
        if name:
            current = installed_softwares(name=name)
        for soft in current:
            if min_version is None:
                return False
            if get_version is not None:
                installed_version = get_version(soft)
            else:
                installed_version = soft['version']
            if Version(min_version) <= installed_version:
                return False
        return True



def create_onboot_task(name, cmd, parameters, max_runtime=10):
    """creates a Windows scheduled task on boot and activate it.

    Args:
        name (str): name of task for reference
        cmd(str) :  command line
        parameters (str) : arguments to append to cmd
        max_runtime (int): maximum running time in minutes

    Returns:
        PyITask: scheduled task
    """
    ts = pythoncom.CoCreateInstance(taskscheduler.CLSID_CTaskScheduler, None,
                                    pythoncom.CLSCTX_INPROC_SERVER,
                                    taskscheduler.IID_ITaskScheduler)

    if '%s.job' % name not in ts.Enum():
        task = ts.NewWorkItem(name)

        task.SetApplicationName(cmd)
        task.SetParameters(parameters)
        task.SetAccountInformation('', None)
        if max_runtime:
            task.SetMaxRunTime(max_runtime * 60*1000)
        #task.SetFlags(task.GetFlags() | taskscheduler.TASK_FLAG_)
        ts.AddWorkItem(name, task)
        run_time = time.localtime(time.time() + 300)
        tr_ind, tr = task.CreateTrigger()
        tt = tr.GetTrigger()
        tt.Flags = 0
        tt.BeginYear = int(time.strftime('%Y', run_time))
        tt.BeginMonth = int(time.strftime('%m', run_time))
        tt.BeginDay = int(time.strftime('%d', run_time))
        tt.TriggerType = int(taskscheduler.TASK_EVENT_TRIGGER_AT_SYSTEMSTART)
        tr.SetTrigger(tt)
        pf = task.QueryInterface(pythoncom.IID_IPersistFile)
        pf.Save(None, 1)
        # task.Run()
    else:
        raise KeyError("%s already exists" % name)

    task = ts.Activate(name)
    #exit_code, startup_error_code = task.GetExitCode()
    return task



def is_kb_installed(hotfixid):
    """Return True or False depending if a Windows update KB is installed.
    """
    installed_update = installed_windows_updates()
    if installed_update:
        if [kb for kb in installed_update if kb['HotFixID'].upper() == hotfixid.upper()]:
            return True
    return False



A utiliser :

if x != y:
os.rename
PackageEntry.inc_build()



A voir :
def ftp_read(url):
    if platform.python_version_tuple()[0] == '3':
        from urllib.request import urlopen
    else:
        from urllib import urlopen
    proxy = get_proxies()
    sock = urlopen(url,proxies=proxy)
    htmlSource = sock.read()
    sock.close()
    return ensure_unicode(htmlSource)


user_home_directory = winshell.folder('profile')
startup = winshell.startup(common=True)
user_startup = winshell.startup()
%SystemRoot%\System32
os.getenv('SystemRoot')



Seulement pour moi :

def remove_extra_keys(dictionnary, list_keys):
    """Removing keys from a dict, dynamicaly.
    """
    for elem in list(dictionnary):
        for del_elem in list_keys:
            if del_elem in elem:
                del dictionnary[del_elem]
    return dictionnary



A ajouter :



def message_box(title, text, style=0):
    if platform.python_version_tuple()[0] == '3':
        import importlib
        importlib.reload(sys)
    else:
        reload(sys)
        sys.setdefaultencoding('utf-8')

    MB_OK = 0
    MB_OKCANCEL = 1
    MB_YESNOCANCEL = 3
    MB_YESNO = 4
    ctypes.windll.user32.MessageBoxW(0, u'%s' % text, u'%s' % title, style)
    return


def message_box_ask_reboot(title, text):
    if platform.python_version_tuple()[0] == '3':
        import importlib
        importlib.reload(sys)
    else:
        reload(sys)
        sys.setdefaultencoding('utf-8')

    ID_OK = 0
    ID_CANCEL = 2
    ID_ABORT = 3
    ID_YES = 6
    ID_NO = 7

    response = ctypes.windll.user32.MessageBoxW(0, u'%s' % text, u'%s' % title, 4)
    if response == ID_YES:
        reboot_machine()
    else:
        pass











def remove_programs_menu_folder(folder):
    """Remove a folder from the start menu of all users

    Args:
        folder(str): folder to remove
    """
    if isdir(makepath(winshell.programs(common=1), folder)):
        remove_tree(makepath(winshell.programs(common=1),folder))




def get_download_url_from_fosshub(url, file_type='64-bit Windows Installer', proxies=None):
    import json
    import requests
    url_api_fosshub = 'https://university.fosshub.com/projects.json'

    for script in bs_find_all(url,'script', proxies=proxies):
        if (len(script.contents) >= 1) and ('var settings' in script.contents[0]):
            var_settings = script.contents[0].replace('\n  var settings =', '').replace('\n','')
            break

    for readapifosshub in json.loads(wgets(url_api_fosshub,proxies=proxies))["projects"]:
        if readapifosshub["url"].endswith(url.split('//')[-1]):
            for filename in readapifosshub["files"]:
                if filename["type"] == file_type:
                    file_name = filename["name"]

    settings = json.loads(var_settings)

    apiUrl = 'https://api.' + settings['domain']
    downloadUrl = apiUrl + '/download/'

    def forming_fosshub_url(a, b, c, d, e):
        params = {  "projectId": a,
                    "releaseId": b,
                    "projectUri": c,
                    "fileName": d,
                    "source": e}
        r = requests.post(downloadUrl, data=params)
        return r

    pool = settings['pool']
    f = pool['f']

    for c in f:
        r = forming_fosshub_url(pool['p'], c['r'], pool['u'], file_name, pool['c'] )

    r = forming_fosshub_url(pool['p'], c['r'], pool['u'], file_name, pool['c'] )
    rj = r.json()
    return rj['data']['url']





Added :

PR :



def get_version_from_binary(filename, parameter='ProductVersion'):
    if filename.endswith('.msi'):
        return get_msi_properties(filename)[parameter]
    else:
        return get_file_properties(filename)[parameter]



def user_home_directory():
    """Return user profile folder

    >>> user_home_directory
    'C:\\Users\\username'
    """
    return winshell.folder('profile')


programdata = programdata()
user_home_directory = user_home_directory()

